(function (global, factory) {
   typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
   typeof define === 'function' && define.amd ? define('ngx-truncate-text', ['exports', '@angular/core'], factory) :
   (factory((global['ngx-truncate-text'] = {}),global.ng.core));
}(this, (function (exports,core) { 'use strict';

   /**
    * @fileoverview added by tsickle
    * Generated from: lib/ngx-truncate-text.ts
    * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
    */
   var NgxTruncateTextDirective = /** @class */ (function () {
       function NgxTruncateTextDirective(elRef, renderer) {
           this.elRef = elRef;
           this.renderer = renderer;
           this.replace = false;
           // elRef will get a reference to the element where
           // the directive is placed
           this.element = elRef.nativeElement;
       }
       /**
        * @return {?}
        */
       NgxTruncateTextDirective.prototype.ngAfterViewInit = /**
        * @return {?}
        */
           function () {
               this.fill(this.element.innerHTML);
           };
       /**
        * @param {?} text
        * @return {?}
        */
       NgxTruncateTextDirective.prototype.fill = /**
        * @param {?} text
        * @return {?}
        */
           function (text) {
               var _this = this;
               this.text = text;
               if (text.length > this.number) {
                   // برای نمایش ادامه یا پنهان
                   /** @type {?} */
                   var remainText = this.completeWord ? this.claculateRemainText() : this.text.substring(0, this.number);
                   this.replace = true;
                   this.element.innerHTML = remainText + ' ... ';
                   /** @type {?} */
                   var span = this.renderer.createElement('span');
                   span.innerHTML = this.more;
                   this.renderer.setStyle(span, 'color', '#ff00ff');
                   this.renderer.addClass(span, 'toggleText');
                   this.renderer.listen(span, 'click', ( /**
                    * @param {?} event
                    * @return {?}
                    */function (event) { return _this.replace === true ? _this.showFullText(event) : _this.hideSomeText(event); }));
                   this.element.appendChild(span);
               }
               else {
                   this.element.innerHTML = this.text;
               }
           };
       /*
       * نمایش کامل متن
       * @param mouseDown {mousedown} mouse event
       */
       /*
         * نمایش کامل متن
         * @param mouseDown {mousedown} mouse event
         */
       /**
        * @param {?} mouseDown
        * @return {?}
        */
       NgxTruncateTextDirective.prototype.showFullText = /*
         * نمایش کامل متن
         * @param mouseDown {mousedown} mouse event
         */
           /**
            * @param {?} mouseDown
            * @return {?}
            */
           function (mouseDown) {
               var _this = this;
               /** @type {?} */
               var span = this.renderer.createElement('span');
               span.innerHTML = this.less;
               this.renderer.setStyle(span, 'color', '#ff00ff');
               this.renderer.addClass(span, 'toggleText');
               this.element.innerHTML = this.text;
               this.renderer.listen(span, 'click', ( /**
                * @param {?} event
                * @return {?}
                */function (event) { return _this.hideSomeText(event); }));
               this.element.appendChild(span);
               // جلوگیری از کلیک روی عنصر پدر
               mouseDown.stopPropagation();
               this.replace = false;
           };
       /*
        * نمایش قسمتی از متن بر اساس تعداد کاراکتر خواسته شده
        * @param mouseDown {mousedown} mouse event
        */
       /*
          * نمایش قسمتی از متن بر اساس تعداد کاراکتر خواسته شده
          * @param mouseDown {mousedown} mouse event
          */
       /**
        * @param {?} mouseDown
        * @return {?}
        */
       NgxTruncateTextDirective.prototype.hideSomeText = /*
          * نمایش قسمتی از متن بر اساس تعداد کاراکتر خواسته شده
          * @param mouseDown {mousedown} mouse event
          */
           /**
            * @param {?} mouseDown
            * @return {?}
            */
           function (mouseDown) {
               var _this = this;
               /** @type {?} */
               var remainText = this.completeWord ? this.claculateRemainText() : this.text.substring(0, this.number);
               /** @type {?} */
               var span = this.renderer.createElement('span');
               this.renderer.setStyle(span, 'color', '#ff00ff');
               this.renderer.addClass(span, 'toggleText');
               span.innerHTML = this.more;
               this.element.innerHTML = remainText + ' ... ';
               this.renderer.listen(span, 'click', ( /**
                * @param {?} event
                * @return {?}
                */function (event) { return _this.showFullText(event); }));
               this.element.appendChild(span);
               // جلوگیری از کلیک روی عنصر پدر
               mouseDown.stopPropagation();
               this.replace = true;
           };
       /*تابع بررسی قطع جمله
        قطع جمله نباید از وسط یک کلمه باشد
      */
       /*تابع بررسی قطع جمله
          قطع جمله نباید از وسط یک کلمه باشد
        */
       /**
        * @return {?}
        */
       NgxTruncateTextDirective.prototype.claculateRemainText = /*تابع بررسی قطع جمله
          قطع جمله نباید از وسط یک کلمه باشد
        */
           /**
            * @return {?}
            */
           function () {
               /** @type {?} */
               var i = 0;
               for (i = this.number; i < this.text.length; i++) {
                   if (this.text[i] == ' ')
                       break;
               }
               return this.text.substring(0, i);
           };
       NgxTruncateTextDirective.decorators = [
           { type: core.Directive, args: [{
                       selector: '[ngxTruncateText]'
                   },] }
       ];
       /** @nocollapse */
       NgxTruncateTextDirective.ctorParameters = function () {
           return [
               { type: core.ElementRef },
               { type: core.Renderer2 }
           ];
       };
       NgxTruncateTextDirective.propDecorators = {
           more: [{ type: core.Input }],
           less: [{ type: core.Input }],
           number: [{ type: core.Input }],
           completeWord: [{ type: core.Input }]
       };
       return NgxTruncateTextDirective;
   }());

   /**
    * @fileoverview added by tsickle
    * Generated from: lib/ngx-truncate-text.module.ts
    * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
    */
   var NgxTruncateTextModule = /** @class */ (function () {
       function NgxTruncateTextModule() {
       }
       NgxTruncateTextModule.decorators = [
           { type: core.NgModule, args: [{
                       declarations: [NgxTruncateTextDirective],
                       imports: [],
                       exports: [NgxTruncateTextDirective]
                   },] }
       ];
       return NgxTruncateTextModule;
   }());

   /**
    * @fileoverview added by tsickle
    * Generated from: public-api.ts
    * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
    */

   /**
    * @fileoverview added by tsickle
    * Generated from: ngx-truncate-text.ts
    * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
    */

   exports.NgxTruncateTextModule = NgxTruncateTextModule;
   exports.NgxTruncateTextDirective = NgxTruncateTextDirective;

   Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-truncate-text.umd.js.map