import { Directive, ElementRef, Input, Renderer2, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-truncate-text.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxTruncateTextDirective {
    /**
     * @param {?} elRef
     * @param {?} renderer
     */
    constructor(elRef, renderer) {
        this.elRef = elRef;
        this.renderer = renderer;
        this.replace = false;
        // elRef will get a reference to the element where
        // the directive is placed
        this.element = elRef.nativeElement;
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.fill(this.element.innerHTML);
    }
    /**
     * @param {?} text
     * @return {?}
     */
    fill(text) {
        this.text = text;
        if (text.length > this.number) {
            // برای نمایش ادامه یا پنهان
            /** @type {?} */
            const remainText = this.completeWord ? this.claculateRemainText() : this.text.substring(0, this.number);
            this.replace = true;
            this.element.innerHTML = remainText + ' ... ';
            /** @type {?} */
            const span = this.renderer.createElement('span');
            span.innerHTML = this.more;
            this.renderer.setStyle(span, 'color', '#ff00ff');
            this.renderer.addClass(span, 'toggleText');
            this.renderer.listen(span, 'click', (/**
             * @param {?} event
             * @return {?}
             */
            (event) => this.replace === true ? this.showFullText(event) : this.hideSomeText(event)));
            this.element.appendChild(span);
        }
        else {
            this.element.innerHTML = this.text;
        }
    }
    /*
      * نمایش کامل متن
      * @param mouseDown {mousedown} mouse event
      */
    /**
     * @param {?} mouseDown
     * @return {?}
     */
    showFullText(mouseDown) {
        /** @type {?} */
        const span = this.renderer.createElement('span');
        span.innerHTML = this.less;
        this.renderer.setStyle(span, 'color', '#ff00ff');
        this.renderer.addClass(span, 'toggleText');
        this.element.innerHTML = this.text;
        this.renderer.listen(span, 'click', (/**
         * @param {?} event
         * @return {?}
         */
        (event) => this.hideSomeText(event)));
        this.element.appendChild(span);
        // جلوگیری از کلیک روی عنصر پدر
        mouseDown.stopPropagation();
        this.replace = false;
    }
    /*
       * نمایش قسمتی از متن بر اساس تعداد کاراکتر خواسته شده
       * @param mouseDown {mousedown} mouse event
       */
    /**
     * @param {?} mouseDown
     * @return {?}
     */
    hideSomeText(mouseDown) {
        /** @type {?} */
        const remainText = this.completeWord ? this.claculateRemainText() : this.text.substring(0, this.number);
        /** @type {?} */
        const span = this.renderer.createElement('span');
        this.renderer.setStyle(span, 'color', '#ff00ff');
        this.renderer.addClass(span, 'toggleText');
        span.innerHTML = this.more;
        this.element.innerHTML = remainText + ' ... ';
        this.renderer.listen(span, 'click', (/**
         * @param {?} event
         * @return {?}
         */
        (event) => this.showFullText(event)));
        this.element.appendChild(span);
        // جلوگیری از کلیک روی عنصر پدر
        mouseDown.stopPropagation();
        this.replace = true;
    }
    /*تابع بررسی قطع جمله
       قطع جمله نباید از وسط یک کلمه باشد
     */
    /**
     * @return {?}
     */
    claculateRemainText() {
        /** @type {?} */
        let i = 0;
        for (i = this.number; i < this.text.length; i++) {
            if (this.text[i] == ' ')
                break;
        }
        return this.text.substring(0, i);
    }
}
NgxTruncateTextDirective.decorators = [
    { type: Directive, args: [{
                selector: '[ngxTruncateText]'
            },] }
];
/** @nocollapse */
NgxTruncateTextDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 }
];
NgxTruncateTextDirective.propDecorators = {
    more: [{ type: Input }],
    less: [{ type: Input }],
    number: [{ type: Input }],
    completeWord: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-truncate-text.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxTruncateTextModule {
}
NgxTruncateTextModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgxTruncateTextDirective],
                imports: [],
                exports: [NgxTruncateTextDirective]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-truncate-text.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxTruncateTextModule, NgxTruncateTextDirective };

//# sourceMappingURL=ngx-truncate-text.js.map